package jlowplugin.server;

import jlowplugin.server.event.*;
import jlowplugin.server.service.*;
import jlowplugin.ui.*;

import cds.aladin.Aladin;

public class AladinJlowServer extends JlowServer {

	private static Aladin aladin;
	private ScriptPane scriptPane;
	
	public AladinJlowServer(Aladin aladin) {
		this(aladin, null);
	}
	
	public AladinJlowServer(Aladin aladin, ScriptPane s) {
		super();
		
		AladinJlowServer.aladin = aladin;
		scriptPane = s;
		
		workmanager.getRegister().addWorkRegisterListener(new ScriptWRListener(scriptPane));
		
		initServices();
	}
	
	/**
	 * Initializes by some script command (from aladin) the register of services.
	 *
	 */
	protected void initServices() {
		services.putService("Load Local", new GetLocal(aladin, scriptPane));
		services.putService("Load Simbad Data", new GetSimbad(aladin, scriptPane));
		services.putService("Load Vizier Data", new GetVizier(aladin, scriptPane));
		services.putService("Load Image", new GetAladin(aladin, scriptPane));
		services.putService("Export Plane", new Export(aladin, scriptPane));
		services.putService("Blink", new Blink(aladin, scriptPane));
		services.putService("RGB", new RGB(aladin, scriptPane));
		services.putService("Contour", new Contour(aladin, scriptPane));
		services.putService("XMatch", new XMatch(aladin, scriptPane));
		services.putService("Load NED Data", new GetNED(aladin, scriptPane));
		services.putService("Sextractor", new Sextractor(aladin, scriptPane));
	}
	
}
