package jlowplugin.server.service;

import java.util.HashMap;

import jlowplugin.ui.ScriptPane;

import cds.aladin.Aladin;
import cds.jlow.descriptor.ITaskDescriptor;
import cds.jlow.server.net.service.AbstractService;
import cds.jlow.server.net.service.IService;

public class Contour  extends AbstractService {

	public Aladin aladin;

	private ScriptPane scriptPane;
	
	public Contour(Aladin aladin) {
		this(aladin, null);
	}
	
	public Contour(Aladin aladin, ScriptPane s) {
		this.aladin = aladin;
		scriptPane = s;
	}
	
	public HashMap execute(ITaskDescriptor desc, HashMap params) {
		HashMap table = new HashMap();

		String planename = (String) params.get("plane name");
		Integer nn = (Integer) params.get("number of contours");
		
		if(planename==null)
			return null;
			
		
		String cmd = "sync; select " + quote(planename) + ";contour ";
		
		if(nn!=null)
			cmd = cmd+nn;
		
		String error = aladin.execCommand(cmd);
		
		if(scriptPane!=null)
			scriptPane.append(cmd);
		
		if(error!=null && !error.trim().equals(""))
			System.out.println("Aladin error :"+error);


		return table;
	}
	
	public String quote(String s) {
		char a[] = s.toCharArray();
		for (int i = 0; i < a.length; i++) {
			if (Character.isWhitespace(a[i]))
				return "\"" + s + "\"";
		}
		return s;
	}

}
