package jlowplugin.server.service;

import java.io.File;
import java.util.HashMap;

import jlowplugin.ui.ScriptPane;

import cds.aladin.Aladin;
import cds.jlow.descriptor.ITaskDescriptor;
import cds.jlow.server.net.service.AbstractService;
import cds.jlow.server.net.service.IService;

public class GetLocal extends AbstractService {
	public static int next = 0;
	public Aladin aladin;
	private ScriptPane scriptPane;
	
	public GetLocal(Aladin aladin) {
		this(aladin, null);
	}
	
	public GetLocal(Aladin aladin, ScriptPane s) {
		this.aladin = aladin;
		scriptPane = s;
	}
	
	public HashMap execute(ITaskDescriptor desc, HashMap params) {
		HashMap table = new HashMap();
		
		String filepath = (String) params.get("file name");
		
		if(filepath==null) {
			aladin.execCommand("get local()"); //~
			return null;
		}
		
		String[] splitFilepath = filepath.split("\\"+File.separator);
		String filename = splitFilepath[splitFilepath.length-1];
		
		// Gets the stack at the moment
//		String[] planesT0 = aladin.getAladinStack();
//		int countPlanesT0 = planesT0.length;
		
		//## Do not load the same file ##
//		for(int iPlaneT0=0;iPlaneT0<countPlanesT0;iPlaneT0++) {
//			System.out.println(planesT0[iPlaneT0]);
//			
//			//Do not load the same file
//			if(planesT0[iPlaneT0].equals(filename)) {
//				System.out.println("File already load in aladin");
//				table.put("result plane", filename);
//				return table;
//			}
//		}
		if(filename==null)
			return null;
		
		// ** Creates the command line and plane name
		String planename = filename+((next>0) ? "~"+next : "");
		next++;
		String cmd = "get Local(";
		if(filepath!=null)
			cmd += "\""+filepath+"\"";
		
		cmd += ")";
		
		//Changes name
		cmd = planename+"="+cmd;
		
		// ** Executes the command line
		String error = aladin.execCommand(cmd);
		scriptPane.append(cmd);
		if(error!=null && !error.trim().equals(""))
			System.out.println(error);
		
		System.out.println("planename : "+planename);
		if(planename!=null && !planename.trim().equals("")) {
			table.put("result plane", planename);
		
		}
		else
			return null; //Else there is a problem
		
		return table;
	}
}
