package jlowplugin.server.service;

import java.util.HashMap;

import jlowplugin.ui.ScriptPane;

import cds.aladin.Aladin;
import cds.jlow.descriptor.ITaskDescriptor;
import cds.jlow.server.net.service.AbstractService;
import cds.jlow.server.net.service.IService;

public class GetNED  extends AbstractService {

	public static Aladin aladin;

	private ScriptPane scriptPane;
	
	public GetNED(Aladin aladin) {
		this(aladin, null);
	}

	public GetNED(Aladin aladin, ScriptPane s) {
		GetNED.aladin = aladin;
		scriptPane = s;
	}
	
	public HashMap execute(ITaskDescriptor desc, HashMap params) {
		HashMap table = new HashMap();
		
		String target = (String) params.get("target");
		String radius = (String) params.get("radius");
		
		if(target==null)
			return null;
		
		if(target.trim().equals("")) {
			aladin.execCommand("get NED");
			return null;
		}
			
		
		// ** Creates the command line and plane name
		String planename = "NED."+target;
		String cmd = "get NED "+target;
		if(radius!=null && !radius.trim().equals("")) {
			cmd += " "+radius;
			planename += "."+radius;
		}
		
		// Changes name
		cmd = planename+"="+cmd;

		// ** Executes the command line
		String id = aladin.execCommand(cmd);
		if(scriptPane!=null)
			scriptPane.append(cmd);
		
		if(id!=null && !id.trim().equals(""))
			System.out.println("Aladin error : "+id);
		
		
		System.out.println("planename : "+planename);
		if(planename!=null)
			table.put("result plane", planename);
		else
			return null;
		
		return table;
	}

}
