package jlowplugin.server.service;

import java.util.HashMap;

import jlowplugin.ui.ScriptPane;

import cds.aladin.Aladin;
import cds.jlow.descriptor.ITaskDescriptor;
import cds.jlow.server.net.service.AbstractService;
import cds.jlow.server.net.service.IService;

public class GetSimbad extends AbstractService {
	protected static int next = 1;
	public Aladin aladin;

	private ScriptPane scriptPane;
	
	public GetSimbad(Aladin aladin) {
		this.aladin = aladin;
	}

	public GetSimbad(Aladin aladin, ScriptPane s) {
		this.aladin = aladin;
		scriptPane = s;
	}
	
	public HashMap execute(ITaskDescriptor desc, HashMap params) {
		HashMap table = new HashMap();

		String target = (String) params.get("target");
		String radius = (String) params.get("radius"); // Optional
		
		if(target==null)
			return null;
		
		if(target.trim().equals("")) {
			aladin.execCommand("get Simbad()");
			return null;
		}
		
		// ** Creates the command line and plane name
		
		String planename = "Simbad."+target+"~"+(next++);
		String cmd = "get Simbad "+target;
		if(radius!=null && !radius.trim().equals("")) {
			cmd += " "+radius;
//			planename += "."+radius;
		}
		
		// Changes name
		cmd = planename+"="+cmd;
		
		// ** Executes the command line
		String error = aladin.execCommand(cmd);
		
		if(scriptPane!=null)
			scriptPane.append(cmd);
		
		if(error!=null && !error.trim().equals(""))
			System.out.println(error);
		
		
		System.out.println("planename : "+planename);
		if(planename!=null)
			table.put("result plane", planename);
		else
			return null;
		
		return table;
	}

}
