package jlowplugin.server.service;

import java.util.HashMap;

import jlowplugin.ui.ScriptPane;

import cds.aladin.Aladin;
import cds.jlow.descriptor.ITaskDescriptor;
import cds.jlow.server.net.service.AbstractService;
import cds.jlow.server.net.service.IService;

public class XMatch extends AbstractService {

	public static int next = 1;
	
	public Aladin aladin;

	private ScriptPane scriptPane;

	public XMatch(Aladin aladin) {
		this(aladin, null);
	}
	
	public XMatch(Aladin aladin, ScriptPane s) {
		this.aladin = aladin;
		scriptPane = s;
	}
	
	public HashMap execute(ITaskDescriptor desc, HashMap params) {
		HashMap table = new HashMap();
		
		String first = (String) params.get("1st catalogue");
		String second = (String) params.get("2nd catalogue");
		String dist = (String) params.get("max dist");

		if(first==null || second==null)
			return null;
		
		aladin.execCommand("sync");
		
//		 Gets the stack at the moment
		String[] planes = aladin.getAladinStack();
		int countPlanes = planes.length;
		
		int numCat1=-1;
		int numCat2=-1;
		
		// Retrieve the number of each catalogue in the stack
		for(int i=0;i<countPlanes;i++) {
			System.out.println(planes[i]);
			if(planes[i].equals(first))
				numCat1=i+1;
			if(planes[i].equals(second))
				numCat2=i+1;
		}
		
		if(numCat1==-1) {
			System.out.println("1st catalogue not found : "+first);
			Aladin.warning("1st catalogue not found : "+first);
			return null;
		}
		if(numCat2==-1) {
			System.out.println("2nd catalogue not found"+second);
			Aladin.warning("2nd catalogue not found"+second);
			return null;
		}

		String planename = "XMatch"+((next>0) ? "~"+next : "");
//		next++;
		String cmd = planename+"=xmatch " + numCat2 + " " + numCat1 + " " + dist;
		String error = aladin.execCommand(cmd);
		
		if(scriptPane!=null)
			scriptPane.append(cmd);
		
		if(error!=null && !error.trim().equals("")) {
			System.out.println("Aladin error : "+error);
			return null;
		}

//		table.put("result plane", planename);
		table.put("result plane", "XMatch results"+(next++));
		
		return table;
	}

//	public String quote(String s) {
//		char a[] = s.toCharArray();
//		for (int i = 0; i < a.length; i++) {
//			if (Character.isWhitespace(a[i]))
//				return "\"" + s + "\"";
//		}
//		return s;
//	}
}
