package jlowplugin.ui;


import java.awt.BorderLayout;
import java.awt.Container;
import java.net.URL;

import javax.swing.*;

import jlowplugin.action.*;
import jlowplugin.server.event.*;
import jlowplugin.server.service.*;
import jlowplugin.ui.action.*;

import cds.aladin.Aladin;

import cds.jlow.client.graph.*;
import cds.jlow.client.sample.service.action.*;
import cds.jlow.client.sample.service.event.*;
import cds.jlow.server.motor.*;
import cds.jlow.server.net.service.*;

public class AladinJlowFrame extends JlowFrame {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private static Aladin aladin;
	private LocalExecServAction execAction;
	
	public AladinJlowFrame(Aladin aladin) {
		super();
		
		AladinJlowFrame.aladin = aladin;
		
		WorkRegister wreg = new WorkRegister();
		wreg.addWorkRegisterListener(new ScriptWRListener(scriptPane));
		
		execAction = new LocalExecServAction(wfEditor, 
				new WorkManager(wreg, getDefaultServices(scriptPane)));
		
		initPopup();
		addToActionMenu();
		
		JToolBar tb = new JToolBar("executionbar");
		toolbar.addToolBar(tb);
//		URL imageURL = this.getClass().getResource("/images/cog.png");
		toolbar.addAction(1, new LocalExecServAction(wfEditor, 
				new WorkManager(wreg, getDefaultServices(scriptPane))), "Execute the current workflow", "Execute", 
				resources.getImage("cog"));
		
//		Container content = getContentPane();
//		content.add(tb, BorderLayout.NORTH);
		
	}
	
	protected void initPopup() {
		// Adds to the popup menu
		DefaultMPopupMenu mpm = (DefaultMPopupMenu) wfEditor.getPopupMenus();
		
		// Execution
		mpm.addSeparator(IManagerPopupMenu.GRAPHMENU);
		mpm.addItem(IManagerPopupMenu.GRAPHMENU, execAction);
		
		ClearAction ca = new ClearAction(wfEditor);
		ca.putValue(Action.NAME, "workflow");
		ClearAladinAction caa = new ClearAladinAction(aladin);
		caa.putValue(Action.NAME, "aladin stack");
		ClearAllAction cAa = new ClearAllAction(wfEditor, aladin);
		cAa.putValue(Action.NAME, "all");
		
		mpm.addSeparator(IManagerPopupMenu.GRAPHMENU);
		JMenu menu = mpm.addSubMenu(IManagerPopupMenu.GRAPHMENU, "Clear");
		menu.add(cAa);
		menu.add(ca);
		menu.add(caa);
		

//		mpm.addSeparator(IManagerPopupMenu.TASKMENU);
//		mpm.addItem(IManagerPopupMenu.TASKMENU, new HelpAction(aladin, wfEditor));
		
	}
	
	public void addToActionMenu() {
		instances.addInstance("actionexecute", execAction);
	}
	
	/**
	 * 
	 * @return
	 */
    public static ServiceRegisterer getDefaultServices(ScriptPane scriptPane) {
    	ServiceRegisterer servregister = new ServiceRegisterer();
    	
    	servregister.putService("Load Local", new GetLocal(aladin, scriptPane));
    	servregister.putService("Load Simbad Data", new GetSimbad(aladin, scriptPane));
    	servregister.putService("Load Vizier Data", new GetVizier(aladin, scriptPane));
    	servregister.putService("Load Image", new GetAladin(aladin, scriptPane));
    	servregister.putService("Export Plane", new Export(aladin, scriptPane));
    	servregister.putService("Blink", new Blink(aladin, scriptPane));
    	servregister.putService("RGB", new RGB(aladin, scriptPane));
    	servregister.putService("Contour", new Contour(aladin, scriptPane));
    	servregister.putService("XMatch", new XMatch(aladin, scriptPane));
    	servregister.putService("Load NED Data", new GetNED(aladin, scriptPane));
    	servregister.putService("Sextractor", new Sextractor(aladin, scriptPane));
		
		return servregister;
    }
	
}
