package jlowplugin.ui;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import javax.swing.*;
import javax.swing.border.*;

import cds.jlow.client.graph.*;

/**
 * @author Cyril Pestel
 * @version 0.5 beta Copyright CDS 2007
 */
public class ToolBar extends JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public static String NAME = "Workflow Toolbar";
	
	public Jlow wfEditor;
	
	public ArrayList toolbars;
	
	public ToolBar(Jlow wfEditor) {
		this.setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
		
		this.wfEditor = wfEditor;
		
		toolbars = new ArrayList();
	}

	public JToolBar getToolBar(int index) {
		return (JToolBar) toolbars.get(index);
	}
	
	public void addToolBar(JToolBar tb) {
		tb.setRollover(false);
		tb.setFloatable(true);
		
		toolbars.add(tb);
		this.add(tb);
	}
	
	public void addAction(int index, Action a, String longdesc, String shortdesc,  ImageIcon smallicon) {		
		a.putValue(Action.LONG_DESCRIPTION, longdesc);
		a.putValue(Action.SHORT_DESCRIPTION, shortdesc);
		a.putValue(Action.SMALL_ICON, smallicon);
		addAction(index, a);
	}
	
	public void addAction(int index, Action a) {
		JToolBar tb = getToolBar(index);
//		JButton bExecute = tb.add(a);
		JButton bExecute = new SmallButton(a);
		tb.add(bExecute);
		bExecute.setFocusable(false);
	}
	
	
	class SmallButton extends JButton implements MouseListener {
		  /**
		 * 
		 */
		private static final long serialVersionUID = 1L;

		protected Border m_raised;

		  protected Border m_lowered;

		  protected Border m_inactive;

		  protected Border m_line;
		  
		  public SmallButton(Action act) {
		    super((Icon) act.getValue(Action.SMALL_ICON));
		    m_line = BorderFactory.createCompoundBorder(new EmptyBorder(1, 3, 1, 3),
		    		BorderFactory.createCompoundBorder(BorderFactory.createLineBorder(Color.GRAY), 
		    				new EmptyBorder(3, 3, 3, 3)));
		    m_raised = new BevelBorder(BevelBorder.RAISED);
		    m_lowered = BorderFactory.createCompoundBorder(new EmptyBorder(1, 3, 1, 3),
		    		BorderFactory.createCompoundBorder(new BevelBorder(BevelBorder.LOWERED) , 
		    				new EmptyBorder(3, 3, 3, 3)));
		    m_inactive = BorderFactory.createCompoundBorder(new EmptyBorder(1, 3, 1, 3),
		    		BorderFactory.createCompoundBorder(BorderFactory.createLineBorder(Color.LIGHT_GRAY), new EmptyBorder(3, 3, 3, 3)));
		    setBorder(m_inactive);
//		    setMargin(new Insets(20, 20, 20, 20));
		    String short_desc = (String) act.getValue(Action.SHORT_DESCRIPTION);
		    if(short_desc!=null) setToolTipText(short_desc);
		    addActionListener(act);
		    addMouseListener(this);
		    setRequestFocusEnabled(false);
		  }

		  public float getAlignmentY() {
		    return 0.5f;
		  }

		  public void mousePressed(MouseEvent e) {
		    setBorder(m_inactive);
		  }

		  public void mouseReleased(MouseEvent e) {
		    setBorder(m_inactive);
		  }

		  public void mouseClicked(MouseEvent e) {
		  }

		  public void mouseEntered(MouseEvent e) {
		    setBorder(m_line);
		  }

		  public void mouseExited(MouseEvent e) {
		    setBorder(m_inactive);
		  }
		}

}
