package jlowplugin.ui.action;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.JSplitPane;

import jlowplugin.ui.JlowFrame;
import jlowplugin.ui.ScriptPane;

public class SwitchScriptPaneAction extends AbstractAction {

//	private ScriptPane scriptPane;
	private double dividerProportion;
	
	public SwitchScriptPaneAction(JlowFrame f) {
		putValue("frame", f);
		dividerProportion = 0.8;
	}
	
	public void actionPerformed(ActionEvent e) {
		JlowFrame frame = (JlowFrame) getValue("frame");
		ScriptPane scriptPane = frame.getScriptPane();
		JSplitPane splitHpane = frame.getSplitHpane();
		
		if(scriptPane.isVisible()) {
			dividerProportion = (double) splitHpane.getDividerLocation()/ (double) splitHpane.getSize().height;
			splitHpane.setDividerLocation(1200);
			splitHpane.setDividerSize(0);
			scriptPane.setVisible(false);
			scriptPane.getParent().getParent().setVisible(false); // ScrollPane
		} else {
			
			splitHpane.setDividerLocation(dividerProportion);
			splitHpane.setDividerSize(4);
			scriptPane.setVisible(true);
			scriptPane.getParent().getParent().setVisible(true); // ScrollPane
		}
	}

}
