package jlowplugin.ui.action;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.JSplitPane;

import jlowplugin.ui.JlowFrame;
import jlowplugin.ui.ScriptPane;

public class SwitchSidebarAction extends AbstractAction {

	private double dividerProportion;
	
	public SwitchSidebarAction(JlowFrame f) {
		putValue("frame", f);
		dividerProportion = 0.2;
	}
	
	public void actionPerformed(ActionEvent e) {
		
		JlowFrame frame = (JlowFrame) getValue("frame");
		JSplitPane splitVpane = frame.getSplitVpane();
		
		if(splitVpane.getDividerSize()!=0) {
			dividerProportion = (double) splitVpane.getDividerLocation()/ (double) splitVpane.getSize().getWidth();
			splitVpane.setDividerSize(0);
			splitVpane.setDividerLocation(0);
		} else {
			
			splitVpane.setDividerLocation(dividerProportion);
			splitVpane.setDividerSize(8);
		}
	}

}
