package jlowplugin.ui.tree.event;

import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;

import javax.swing.JTree;
import javax.swing.tree.*;

import cds.jlow.descriptor.ITaskDescriptor;

import jlowplugin.ui.StateBar;

public class TreeMouseMotionListener extends MouseMotionAdapter {

	private JTree tree;
	private StateBar stateBar;
	
	public TreeMouseMotionListener(JTree tree, StateBar stateBar) {
		this.tree = tree;
		this.stateBar = stateBar;
	}
	
	public void mouseMoved(MouseEvent event) {
		Object component = null;
		TreePath path = tree.getPathForLocation(event.getX(), event.getY());
		if(path!=null)
			component = path.getLastPathComponent();
		else
			this.stateBar.clearComment();
		
		if(component!=null) {
//			System.out.println("component : "+component+" ("+component.getClass()+")");
			String text = null;
			component = ((DefaultMutableTreeNode) component).getUserObject();
			
			if(component instanceof ITaskDescriptor) {
				Object comment = ((ITaskDescriptor) component).getAtt("comment");
				if(comment!=null)
					text = comment.toString();
				else
					text = ((ITaskDescriptor) component).getName();
//				System.out.println("task");
			}
			else
				text = component.toString();
			
//			if(text!=null)
				stateBar.setComment(text);
		}
		
	}
	
	
}
