package jlowplugin.ui;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Enumeration;

import javax.swing.*;

public class AboutDialog extends JDialog implements ActionListener {

	protected static String DEFAULTTEXT="<html>Jlow Plugin v.0.3 (c) 2007<br>" +
			"The plugin uses  : <ul>" +
			"<li>JLOW 2.0 library (For more details, refer to the copyright from <a href='http://cdsweb.u-strasbg.fr/devcorner.gml'>http://cdsweb.u-strasbg.fr/devcorner.gml</a>)</li>" +
			"<li>JGraph (For more details, refer to the copyright from <a href='http://www.jgraph.com/downloads.html'>http://www.jgraph.com/downloads.html</a>)</li>" +
			"<li>KXML 2 (For more details, refer to the copyright from <a href='http://www.kxml.org/'>http://www.kxml.org</a>)</li>" +
			"<li>Commons logging from the Jakarta project (For more details, refer to the copyright from <a href='http://commons.apache.org/logging'>http://commons.apache.org/logging/</a>)</li>" +
			"</ul>" +
			"<br>" +
			"Please Visit <a href='http://aladin.u-strasbg.fr/java/nph-aladin.pl?frame=plugRep'>" +
			"http://aladin.u-strasbg.fr/java/nph-aladin.pl?frame=plugRep</a> for more details about plugins.</html>";
	
	public static String LICENCE="In accordance with the international conventions about intellectual\n" +
	"property rights this software and associated documentation files\n" +
	"(the \"Software\") is protected. The rightholder authorizes :\n" +
	"the reproduction and representation as a private copy or for educational\n" +
	"and research purposes outside any lucrative use,\n" +
	"subject to the following conditions:\n" +
	"\n" +
	"The above copyright notice shall be included.\n" +
	"\n" +
	"THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND,\n" +
	"EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES\n" +
	"OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, NON INFRINGEMENT,\n" +
	"LOSS OF DATA, LOSS OF PROFIT, LOSS OF BARGAIN OR IMPOSSIBILITY\n" +
	"TO USE SUCH SOFWARE. IN NO EVENT SHALL THE RIGHTHOLDER BE LIABLE\n" +
	"FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,\n" +
	"TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH\n" +
	"THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n" +
	"\n" +
	"For any other exploitation contact the rightholder.\n" +
	"\n" +
	"Portions of the code has been developed in the framework of the\n" +
	"EuroVO VOTech project (2005-2008).\n" +
	"\n" +
	"Portions of the code (JLOW library) has been developed in the framework of the\n" +
	"MDA French Ministry ACI (2003-2006).\n"
	;//+
//	"-----------\n" +
//	"\n" +
//	"Conformement aux conventions internationales relatives aux droits de\n" +
//	"propriete intellectuelle ce logiciel et sa documentation sont proteges.\n" +
//	"Le titulaire des droits autorise :\n" +
//	"la reproduction et la representation a titre de copie privee ou des fins\n" +
//	"d'enseignement et de recherche et en dehors de toute utilisation lucrative.\n" +
//	"Cette autorisation est faite sous les conditions suivantes :\n" +
//	"\n" +
//	"La mention du copyright portee ci-dessus devra etre clairement indiquee.\n" +
//	"\n" +
//	"LE LOGICIEL EST LIVRE \"EN L'ETAT\", SANS GARANTIE D'AUCUNE SORTE.\n" +
//	"LE TITULAIRE DES DROITS NE SAURAIT, EN AUCUN CAS ETRE TENU CONTRACTUELLEMENT\n" +
//	"OU DELICTUELLEMENT POUR RESPONSABLE DES DOMMAGES DIRECTS OU INDIRECTS\n" +
//	"(Y COMPRIS ET A TITRE PUREMENT ILLUSTRATIF ET NON LIMITATIF,\n" +
//	"LA PRIVATION DE JOUISSANCE DU LOGICIEL, LA PERTE DE DONNEES,\n" +
//	"LE MANQUE A GAGNER OU AUGMENTATION DE COUTS ET DEPENSES, LES PERTES\n" +
//	"D'EXPLOITATION,LES PERTES DE MARCHES OU TOUTES ACTIONS EN CONTREFACON)\n" +
//	"POUVANT RESULTER DE L'UTILISATION, DE LA MAUVAISE UTILISATION\n" +
//	"OU DE L'IMPOSSIBILITE D'UTILISER LE LOGICIEL, ALORS MEME\n" +
//	"QU'IL AURAIT ETE AVISE DE LA POSSIBILITE DE SURVENANCE DE TELS DOMMAGES.\n" +
//	"\n" +
//	"Pour toute autre utilisation contactez le titulaire des droits.\n";
	
	public static String CREDITS = "Written by :\n" +
	"    Cyril Pestel <pestel@cluster.u-strasbg.fr>\n" +
	"\n" +
	"Email contacts : \n" +
	"    question@simbad.u-strasbg.fr";
	
	private String text;
	private ImageIcon icon;
	private ButtonGroup buttons;
	
	private JDialog licence;
	private JDialog credits;
	
	public AboutDialog(Frame owner) {
		super(owner, true);
		
		
		Container c = getContentPane();
		c.setLayout(new BorderLayout());
		
		setText(AboutDialog.DEFAULTTEXT);
		//TODO : Icon
		buttons = createGroup(new String[] {"Credits", "Licence", "Close"});
		
		JOptionPane op = new JOptionPane(LICENCE, // Message
			    JOptionPane.PLAIN_MESSAGE, // Type
			    JOptionPane.CLOSED_OPTION // Option
	    );
		licence = op.createDialog(owner, // Parent component 
				"Licence"); // Title
		
		op = new JOptionPane(CREDITS, // Message
			    JOptionPane.PLAIN_MESSAGE, // Type
			    JOptionPane.CLOSED_OPTION // Option
	    );
		credits = op.createDialog(owner, // Parent component 
				"Credits"); // Title
		
		// ** Adds components
		c.add(createTextPanel(), BorderLayout.CENTER);
		c.add(createButtonPanel(), BorderLayout.SOUTH);
		
		// ** Sets title
		setTitle("About JlowPlugin");
//		setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
		this.pack();
		if(owner!=null) {
			Point p = owner.getLocation();
			p.translate(200, 100);
			this.setLocation(p);
			licence.setLocation(p);
			p.translate(100, 50);
			credits.setLocation(p);
		} else
			this.setLocation(200, 100);
	}

	protected ButtonGroup createGroup(String values[]) {
		// Group the radio buttons.
		ButtonGroup group = new ButtonGroup();
		int valueCount = values.length;
		for(int iValue=0;iValue<valueCount;iValue++) {
			JButton rb = new JButton(values[iValue]);
			rb.addActionListener(this);
			group.add(rb);
		}

		return group;
	}

	protected JPanel createButtonPanel() {
		JPanel pButton = new JPanel();
		for(Enumeration enButton = buttons.getElements();enButton.hasMoreElements();) {
			Object b = enButton.nextElement();
			((JButton) b).setFont(new Font("SansSerif",Font.PLAIN,10));
//			System.out.println("radio : "+b); //JButton
			pButton.add((JButton) b);
		}

		return pButton;
	}
	
	protected JPanel createTextPanel() {
		JPanel pText = new JPanel();
		pText.setBorder(BorderFactory.createEmptyBorder(10,20,5,10));
		JLabel lText = new JLabel(text);
		lText.setFont(new Font("SansSerif",Font.PLAIN,12));
		pText.add(lText);
		
		return pText;
	}

	public void setText(String t) {
		text = t;
	}

	public void actionPerformed(ActionEvent e) {
		Object source = e.getSource();
		
		if(source!=null && source instanceof JButton) {
			JButton b = (JButton) source;
			String bText = b.getText();
			if(bText.equals("Close"))
				this.setVisible(false);
			else if(bText.equals("Licence"))
				licence.setVisible(true);
			else if(bText.equals("Credits"))
				credits.setVisible(true);
		}
	}
	
}
